(module appel-postgres (main call-post) 
  (extern 
   (type sshort short "sshort") 
   (type sint short "sint") )
  (include "./Entetes-Postgres/mes-entetes.inc") 
  (extern 
   (include "./Entetes-Postgres/mes-entetes.h") 
   (PQstatus::ConnStatusType (PGconn*) "PQstatus")
   (PQerrorMessage::string (PGconn*) "PQerrorMessage")
   (PQfinish::void (PGconn*) "PQfinish") 
   (PQhost::string (PGconn*) "PQhost")  
   (PQdb::string (PGconn*) "PQdb")
   (PQsetdbLogin::PGconn* (string string string string string string string)
			  "PQsetdbLogin") 
   (PQtty::string (PGconn*) "PQtty")
   (PQtrace::void (PGconn* FILE) "PQtrace") 
   (PQexec::PGresult* (PGconn* string) "PQexec") 
   (PQclear::void (PGresult*) "PQclear") 
   (PQresultStatus::ExecStatusType (PGresult*) "PQresultStatus") 
   (PQntuples::int (PGresult*) "PQntuples")
   (PQprintTuples::void (PGresult* FILE int int int) "PQprintTuples") 
   (PQprint::void (FILE PGresult* PQprintOpt*) "PQprint")
   ))

(define *Print-Options*
      (PQprintOPt* (integer->char 1)
		   (integer->char 1)
		   (integer->char 0)
		   (integer->char 0)
		   (integer->char 0)
		   (integer->char 0)
		   "|"
		   ""
		   ""
		   (let ((opt (make-string* 2)))
		      (string*-set! opt 0 "toto")
		      (string*-set! opt 1 string-null)
		      opt)))

(define (call-post argl)
  (let ((base (cadr argl)))
;	(sql-file (caddr argl)))

    (let ((p-conn (PQsetdbLogin "" "" "" "" base "bloch" "")))

       (PQtrace p-conn (current-output-port))
       (if (=ConnStatusType? (PQstatus p-conn) 
			    (ConnStatusType-CONNECTION_BAD))
	  (print "chec  la connexion")
	  (begin
	     (print "a dmarre !")
	     (let ((ptr->fieldSep
		     (PQprintOPt*-fieldSep *Print-Options*)))
		(print  ptr->fieldSep))
	     (let ((ptr->fieldName
		     (PQprintOPt*-fieldName *Print-Options*)))
		(print (if (string*-null? ptr->fieldName)
			   "NULL"
			   (string*-ref ptr->fieldName 0))))
	     (print (PQdb p-conn))
;;	     (print (PQstatus p-conn))
	     (print (PQerrorMessage p-conn))
	     (let ((reponse (PQexec p-conn "select * from meteo;")))
		(PQprintTuples reponse
			       (current-output-port) 
			       0 0 0)
		(PQprint (current-output-port)
			 reponse
			 *Print-Options*))
	    (PQfinish p-conn)
	    (print "c'est fini !"))))))

(define (execute conn question)
  (let ((p-result (PQexec conn question)))
    (cond ((=ExecStatusType? (PQresultStatus p-result) 
			     (ExecStatusType-PGRES_COMMAND_OK))
	   (print (PQerrorMessage conn))
	   (newline)
	   (print (PQresultStatus p-result))
	   (newline))
	  ((=ExecStatusType? (PQresultStatus p-result) 
			     (ExecStatusType-PGRES_TUPLES_OK))
	   (print (PQerrorMessage conn))
	   (newline)
	   (print (PQresultStatus p-result))
	   (PQprintTuples p-result (current-output-port) 0 0 0)
	   (newline))
	  (else
	   (newline)
	   (print "chec de l'action : ")
	   (print (PQresultStatus p-result))
	   (print (PQerrorMessage conn))))
    (PQclear p-result)))

(define (get-question flux-sql)
   (read-line))
  
(define (trime-incommente chaine)
  (letrec ((dernier 
	    (lambda (chaine)
	      (let ((l (string-length chaine)))
		(string-ref chaine (- l 1)))))
	   (trime-avant 
	    (lambda (chaine)
	      (let ((l (string-length chaine)))
		(if (char-whitespace? (string-ref chaine 0))
		    (trime-avant (substring chaine 1 l))
		    chaine))))
	   (trime-arriere
	    (lambda (chaine)
	      (let ((l (string-length chaine)))
		(if (char-whitespace? (dernier chaine))
		    (trime-arriere (substring chaine 0 (- l 1))) 
		    chaine))))
	   )
    #f)
  #f)



(define (trime-arriere chaine)
  (if (string=? (dernier chaine) " ")
      (trime-arriere (substring chaine 0 (- (string-length chaine) 1)))
      chaine))

(define (action-liste action-flux)
  (let boucle ((actions-la-liste '()))
    (if (eof-object? (peek-char action-flux))
	(begin
	  (close-input-port action-flux)
	  actions-la-liste)
	(boucle (append actions-la-liste (list (read-line action-flux)))))))
;	(boucle (append actions-la-liste (action-add action-flux))))))

(define (action-add flux)
  (let boucle ((action-une "")
	       (ligne (trime (read-line flux))))
    (if (string=? ";" (dernier ligne))
	(list (string-append action-une " " ligne))
	(boucle (string-append action-une " " ligne)
		(trime (read-line flux))))))

(define (dernier chaine)
  (let ((longueur (string-length chaine)))
    (substring chaine (- longueur 1) longueur)))

(define (trime-avant chaine)
  (if (string=? (substring chaine 0 1) " ")
      (trime-avant (substring chaine 1 (string-length chaine)))
      chaine))

(define (trime chaine)
  (trime-arriere (trime-avant chaine)))
